; baricon.s

VTiInternet	*	&a42c0
ReadConfigure	*	VTiInternet+0
WriteConfigure	*	VTiInternet+1
EraseConfigure	*	VTiInternet+2
EraseProgram	*	VTiInternet+3
DownloadError	*	VTiInternet+4
DownloadPassword *	VTiInternet+5
ConfWindows	*	VTiInternet+6
CheckFilter	*	VTiInternet+7

	GET	macros.s

	IMPORT	rmalloc

	AREA	|____VTiInternet_GetErrorCode|, CODE, READONLY
	EXPORT	VTiInternet_GetErrorCode
VTiInternet_GetErrorCode

	STMFD	r13!,{r14}
	MOV	r0,#0
	SWI	DownloadError
	MOVVS	r0,#0
 [ arm32
	LDMVSFD	r13!,{pc}
 |
	LDMVSFD	r13!,{pc}^
 ]
	BL	rmalloc
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{pc}
 |
	LDMEQFD	r13!,{pc}^
 ]
	LDR	r1,=VTiErrorAddr
	STR	r0,[r1]
	SWI	DownloadError
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

	AREA	VTiErrorAddr, DATA
	%	4

	AREA	|____VTiInternet_GetPassword|, CODE, READONLY
	EXPORT	VTiInternet_GetPassword
VTiInternet_GetPassword

	STMFD	r13!,{r4,r14}
	MOV	r0,#0
	SWI	DownloadPassword
	MOVVS	r0,#0
 [ arm32
	LDMVSFD	r13!,{r4,pc}
 |
	LDMVSFD	r13!,{r4,pc}^
 ]
	BL	rmalloc
	TEQ	r0,#0
 [ arm32
	LDMEQFD	r13!,{r4,pc}
 |
	LDMEQFD	r13!,{r4,pc}^
 ]
	LDR	r1,=VTI_PASSPTR
	STR	r0,[r1]
	LDR	r1,=VTI_PASSTEXT
	LDR	r2,=VTI_BUTTON
	LDR	r3,=VTI_PASSWORD
	LDR	r4,=VTI_PASSTYPE
	SWI	DownloadPassword
	LDR	r1,=VTI_PASSPTR
	LDR	r1,[r1]
	SWI	XWimp_CreateWindow
	MOVVS	r0,#0
 [ arm32
	LDMVSFD	r13!,{r4,pc}
 |
	LDMVSFD	r13!,{r4,pc}^
 ]
	LDMFD	r13!,{r4,lr}

	IMPORT	canvas_addtolist
	B	canvas_addtolist

	AREA	VTiInternet_PasswordData, DATA
	EXPORT	VTI_BUTTON
	EXPORT	VTI_PASSWORD
	EXPORT	VTI_PASSTYPE
	EXPORT	VTI_PASSTEXT

VTI_PASSPTR
	%	4
VTI_BUTTON
	=	"Cancel",0
	ALIGN
	DCD	0,0
VTI_PASSWORD
	%	16
VTI_PASSTYPE
	=	"Password:",0
	ALIGN
	DCD	0,0
VTI_PASSTEXT
	%	256

	AREA	|____VTiInternet_CauseError|, CODE, READONLY
	EXPORT	VTiInternet_CauseError
VTiInternet_CauseError

; r0 is ^ error
; r1 is 1st button
; r2 is 2nd button
; r3 is 3rd button
; !r13 is 4th button

	MOV	r12,r13
	STMFD	r13!,{r4,lr}
	LDR	r4,[r12]
	LDR	r12,=VTiErrorAddr
	LDR	r12,[r12]
	MOV	lr,pc
	MOV	pc,r12
 [ arm32
	LDMFD	r13!,{r4,pc}
 |
	LDMFD	r13!,{r4,pc}^
 ]

	AREA	|____VTiInternet_ReadConfigure|, CODE, READONLY
	EXPORT	VTiInternet_ReadConfigure
VTiInternet_ReadConfigure

	SWI	ReadConfigure
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____VTiInternet_WriteConfigure|, CODE, READONLY
	EXPORT	VTiInternet_WriteConfigure
VTiInternet_WriteConfigure

	SWI	WriteConfigure
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____VTiInternet_EraseConfigure|, CODE, READONLY
	EXPORT	VTiInternet_EraseConfigure
VTiInternet_EraseConfigure

	SWI	EraseConfigure
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____VTiInternet_EraseProgram|, CODE, READONLY
	EXPORT	VTiInternet_EraseProgram
VTiInternet_EraseProgram

	SWI	EraseProgram
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____VTI_FOREC|, NOINIT
	EXPORT	VTI_FOREC
VTI_FOREC

	%	4

	AREA	|____VTI_BACKC|, NOINIT
	EXPORT	VTI_BACKC
VTI_BACKC

	%	4

	AREA	VTI_BOTTOMTXT, DATA
	=	"Save",0
	ALIGN
	DCD	0,0

	AREA	VTI_MIDDLETXT, DATA
	=	"Restore",0
	ALIGN
	DCD	0,0

	AREA	VTI_TOPTXT, DATA
	=	"Cancel",0
	ALIGN
	DCD	0,0

	AREA	VTiInternet_TempWorkspace, NOINIT
	%	32

	AREA	VTiInternet_Vars, NOINIT
	EXPORT	VTI_CWOX
	EXPORT	VTI_CWOY
	EXPORT	VTI_CWWIDTH
	EXPORT	VTI_CWHEIGHT

VTI_CWOX
	%	4
VTI_CWOY
	%	4
VTI_CWWIDTH
	%	4
VTI_CWHEIGHT
	%	4

	AREA	|____VTiInternet_ConfigureWindows|, CODE, READONLY
	EXPORT	VTiInternet_ConfigureWindows
VTiInternet_ConfigureWindows

; r0 is ^ text
; r1 is height

	STMFD	r13!,{r4-r7,lr}
	LDR	r2,=VTiInternet_TempWorkspace
	LDR	r3,=VTI_BOTTOMTXT
	LDR	r4,=VTI_MIDDLETXT
	LDR	r5,=VTI_TOPTXT
	SWI	ConfWindows
	MOVVS	r0,#0
 [ arm32
	LDMVSFD	r13!,{r4-r7,pc}
 |
	LDMVSFD	r13!,{r4-r7,pc}^
 ]
	LDR	r6,=VTI_CWOX
	STMIA	r6,{r2-r5}
	MOV	r4,r1
	BL	canvas_addtolist
	LDR	r1,=VTI_BACKC
	STR	r0,[r1]
	MOV	r0,r4
	BL	canvas_addtolist
	LDR	r1,=VTI_FOREC
	STR	r0,[r1]
	MOV	r0,#1
 [ arm32
	LDMFD	r13!,{r4-r7,pc}
 |
	LDMFD	r13!,{r4-r7,pc}^
 ]

	AREA	|____VTiInternet_SetDriver|, CODE, READONLY
	EXPORT	VTiInternet_SetDriver
VTiInternet_SetDriver

	LDR	r1,=DriverAddr
	STR	r0,[r1]
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	DriverAddr, NOINIT
	%	4

	AREA	|____Driver|, CODE, READONLY
	EXPORT	Driver
Driver

	STMFD	r13!,{r14}
	LDR	r12,=DriverAddr
	LDR	r12,[r12]
	TEQ	r12,#0
	MOVNE	lr,pc
	MOVNE	pc,r12
 [ arm32
	LDMFD	r13!,{pc}
 |
	LDMFD	r13!,{pc}^
 ]

	AREA	|____VTi_VSync|, CODE, READONLY
	EXPORT	VTi_VSync
VTi_VSync

	MOV	r0,#19
	SWI	XOS_Byte
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	AREA	|____VTiInternet_CheckFilter|, CODE, READONLY
	EXPORT	VTiInternet_CheckFilter
VTiInternet_CheckFilter

	SWI	CheckFilter
 [ arm32
	MOV	pc,lr
 |
	MOVS	pc,lr
 ]

	END
